<?php
/**
 * @version		$Id$
 * @package		slovu.net
 * @subpackage	Content
 * @copyright	Copyright (C) 2012 http://slovu.net. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 */

// No direct access
defined('_JEXEC') or die;
jimport('joomla.plugin.plugin');

/**
 * Codehighlighter Content Plugin
 *
 * @package		Joomla
 * @subpackage	Content
 * @since		2.5
 */
class plgContentCodehighlighter extends JPlugin
{
	var $_alreadyRun=FALSE;
	/**
	 *
	 *
	 * @param	string	The context of the content being passed to the plugin.
	 * @param	object	The content object.  Note $article->text is also available
	 * @param	object	The content params
	 * @param	int		The 'page' number
	 * @since	2.5
	 */

	public function onContentPrepare($context, &$article, &$params, $limitstart)
	{

		if (JString::strpos($article->text, 'pre>') === false) {
			return true;
		}

		$regex = "#<pre class=\"brush:\s*(.*?)\">#s";
		preg_match_all($regex,$article->text,$mass);

		$this->_alreadyRun=TRUE;
		$version=$this->params->get('version');
		$syntaxPath=JURI::root(true).'/plugins/content/codehighlighter/syntaxhighlighter3/';
		if($version==2){
			$syntaxPath=JURI::root(true).'/plugins/content/codehighlighter/syntaxhighlighter2/';
			$this->loadV2($syntaxPath,$mass);
		}else {
			$this->loadV3($syntaxPath,$mass);
		}
		
		return true;
	}
	
	private function loadV3($syntaxPath,$mass){
		$document = JFactory::getDocument();
		$document->addScript($syntaxPath.'scripts/shCore.js');
		for ($wi=0; $wi< count($mass[1]); $wi++) {
		  $document->addScript( $syntaxPath.'scripts/shBrush'.$mass[1][$wi].'.js' );
		}
        $theme=$this->params->get('theme','Default');        
		$document->addStyleSheet($syntaxPath.'styles/shCore'.$theme.'.css');
		$document->addStyleSheet($syntaxPath.'styles/shTheme'.$theme.'.css');
		$document->addScriptDeclaration("SyntaxHighlighter.all({'toolbar':false});");
	}
	private function loadV2($syntaxPath,$mass){
		$document = JFactory::getDocument();
		$document->addScript($syntaxPath.'scripts/shCore.js');
		for ($wi=0; $wi< count($mass[1]); $wi++) {
		  $document->addScript( $syntaxPath.'scripts/shBrush'.$mass[1][$wi].'.js' );
		}
		$theme=$this->params->get('theme','Default');   
		$document->addStyleSheet($syntaxPath.'styles/shCore.css');
		$document->addStyleSheet($syntaxPath.'styles/shTheme'.$theme.'.css');
		$document->addScriptDeclaration('SyntaxHighlighter.config.clipboardSwf = "'.$syntaxPath.'scripts/clipboard.swf";SyntaxHighlighter.all();');
	}


}
